Index: /NEMO/trunk/src/ICE/icedyn_adv_umx.F90
===================================================================
--- /NEMO/trunk/src/ICE/icedyn_adv_umx.F90	(revision 10424)
+++ /NEMO/trunk/src/ICE/icedyn_adv_umx.F90	(revision 10425)
@@ -35,5 +35,5 @@
    REAL(wp) ::   z1_120 = 1._wp / 120._wp   ! =1/120
 
-   REAL(wp), DIMENSION(:,:), ALLOCATABLE :: amaxu, amaxv
+   REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: amaxu, amaxv
    
    ! advect H all the way (and get V=H*A at the end)
@@ -119,8 +119,16 @@
       INTEGER  ::   icycle                  ! number of sub-timestep for the advection
       REAL(wp) ::   zamsk                   ! 1 if advection of concentration, 0 if advection of other tracers
-      REAL(wp) ::   zcfl , zdt
-      REAL(wp), DIMENSION(jpi,jpj) ::   zudy, zvdx, zcu_box, zcv_box, zua_ho, zva_ho
-      REAL(wp), DIMENSION(jpi,jpj) ::   zhvar
-      REAL(wp), DIMENSION(jpi,jpj) ::   zati1, zati2, z1_ai, z1_aip
+      REAL(wp) ::   zdt
+      REAL(wp), DIMENSION(1)       ::   zcflprv, zcflnow   ! send zcflnow and receive zcflprv
+      REAL(wp), DIMENSION(jpi,jpj) ::   zudy, zvdx
+      REAL(wp), DIMENSION(jpi,jpj) ::   zati1, zati2
+
+
+
+      REAL(wp), DIMENSION(jpi,jpj)     ::   zcu_box, zcv_box
+      REAL(wp), DIMENSION(jpi,jpj,jpl) ::   zua_ho, zva_ho
+      REAL(wp), DIMENSION(jpi,jpj,jpl) ::   z1_ai, z1_aip
+      REAL(wp), DIMENSION(jpi,jpj,jpl) ::   zhvar
+
       !!----------------------------------------------------------------------
       !
@@ -128,11 +136,15 @@
       !
       !
-      ! --- If ice drift field is too fast, use an appropriate time step for advection (CFL test for stability) --- !        
-      zcfl  =            MAXVAL( ABS( pu_ice(:,:) ) * rdt_ice * r1_e1u(:,:) )
-      zcfl  = MAX( zcfl, MAXVAL( ABS( pv_ice(:,:) ) * rdt_ice * r1_e2v(:,:) ) )
-      IF( lk_mpp )   CALL mpp_max( zcfl )
-
-      IF( zcfl > 0.5 ) THEN   ;   icycle = 2 
-      ELSE                    ;   icycle = 1 
+      ! --- If ice drift field is too fast, use an appropriate time step for advection (CFL test for stability) --- !
+      !     When needed, the advection split is applied at the next time-step in order to avoid blocking global comm.
+      !     ...this should not affect too much the stability... Was ok on the tests we did...
+      zcflnow(1) =                  MAXVAL( ABS( pu_ice(:,:) ) * rdt_ice * r1_e1u(:,:) )
+      zcflnow(1) = MAX( zcflnow(1), MAXVAL( ABS( pv_ice(:,:) ) * rdt_ice * r1_e2v(:,:) ) )
+      
+      ! non-blocking global communication send zcflnow and receive zcflprv
+      CALL mpp_delay_max( 'icedyn_adv_umx', 'cflice', zcflnow(:), zcflprv(:), kt == nitend - nn_fsbc + 1 )
+
+      IF( zcflprv(1) > .5 ) THEN   ;   icycle = 2
+      ELSE                         ;   icycle = 1
       ENDIF
       
@@ -159,6 +171,6 @@
 
       IF( ll_zeroup2 ) THEN
-         IF(.NOT. ALLOCATED(amaxu))       ALLOCATE(amaxu (jpi,jpj))
-         IF(.NOT. ALLOCATED(amaxv))       ALLOCATE(amaxv (jpi,jpj))
+         IF(.NOT. ALLOCATED(amaxu))       ALLOCATE(amaxu (jpi,jpj,jpl))
+         IF(.NOT. ALLOCATED(amaxv))       ALLOCATE(amaxv (jpi,jpj,jpl))
       ENDIF
       !---------------!
@@ -167,83 +179,91 @@
       DO jt = 1, icycle
 
-         IF( ll_ADVopw ) THEN
-            zamsk = 1._wp
-            CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zudy, zvdx, zcu_box, zcv_box, pato_i(:,:), pato_i(:,:) )   ! Open water area 
-            zamsk = 0._wp
-         ELSE
+!!$         IF( ll_ADVopw ) THEN
+!!$            zamsk = 1._wp
+!!$            CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zudy, zvdx, zcu_box, zcv_box, pato_i(:,:), pato_i(:,:) )   ! Open water area 
+!!$            zamsk = 0._wp
+!!$         ELSE
             zati1(:,:) = SUM( pa_i(:,:,:), dim=3 )
-         ENDIF
+!!$         ENDIF
          
-         DO jl = 1, jpl
+         WHERE( pa_i(:,:,:) >= epsi20 )   ;   z1_ai(:,:,:) = 1._wp / pa_i(:,:,:)
+         ELSEWHERE                        ;   z1_ai(:,:,:) = 0.
+         END WHERE
             !
-            WHERE( pa_i(:,:,jl) >= epsi20 )   ;   z1_ai(:,:) = 1._wp / pa_i(:,:,jl)
-            ELSEWHERE                         ;   z1_ai(:,:) = 0.
-            END WHERE
-            !
-            WHERE( pa_ip(:,:,jl) >= epsi20 )  ;   z1_aip(:,:) = 1._wp / pa_ip(:,:,jl)
-            ELSEWHERE                         ;   z1_aip(:,:) = 0.
-            END WHERE
-            !
-            IF( ll_zeroup2 ) THEN
+         WHERE( pa_ip(:,:,:) >= epsi20 )  ;   z1_aip(:,:,:) = 1._wp / pa_ip(:,:,:)
+         ELSEWHERE                        ;   z1_aip(:,:,:) = 0.
+         END WHERE
+         !
+         IF( ll_zeroup2 ) THEN
+            DO jl = 1, jpl
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1
-                     amaxu(ji,jj)=MAX( pa_i(ji,jj,jl), pa_i(ji,jj-1,jl), pa_i(ji,jj+1,jl), &
-                        &                              pa_i(ji+1,jj,jl), pa_i(ji+1,jj-1,jl), pa_i(ji+1,jj+1,jl) )
-                     amaxv(ji,jj)=MAX( pa_i(ji,jj,jl), pa_i(ji-1,jj,jl), pa_i(ji+1,jj,jl), &
-                        &                              pa_i(ji,jj+1,jl), pa_i(ji-1,jj+1,jl), pa_i(ji+1,jj+1,jl) )
-                 END DO
-               END DO
-               CALL lbc_lnk_multi(amaxu, 'T', 1., amaxv, 'T', 1.)
-            ENDIF
+                     amaxu(ji,jj,jl)=MAX( pa_i(ji,jj,jl), pa_i(ji,jj-1,jl), pa_i(ji,jj+1,jl), &
+                        &                                 pa_i(ji+1,jj,jl), pa_i(ji+1,jj-1,jl), pa_i(ji+1,jj+1,jl) )
+                     amaxv(ji,jj,jl)=MAX( pa_i(ji,jj,jl), pa_i(ji-1,jj,jl), pa_i(ji+1,jj,jl), &
+                        &                                 pa_i(ji,jj+1,jl), pa_i(ji-1,jj+1,jl), pa_i(ji+1,jj+1,jl) )
+                  END DO
+               END DO
+            END DO
+            CALL lbc_lnk_multi('icedyn_adv_umx', amaxu, 'T', 1., amaxv, 'T', 1.)
+         ENDIF
+         !
+         DO jl = 1, jpl
+            zua_ho(:,:,jl) = zudy(:,:)
+            zva_ho(:,:,jl) = zvdx(:,:)
+         END DO
+         
+         zamsk = 1._wp
+         CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho, zva_ho, zcu_box, zcv_box, pa_i, pa_i, zua_ho, zva_ho ) ! Ice area
+         zamsk = 0._wp
+         !
+         IF( ll_thickness ) THEN
+            DO jl = 1, jpl
+               zua_ho(:,:,jl) = zudy(:,:)
+               zva_ho(:,:,jl) = zvdx(:,:)
+            END DO
+         ENDIF
             !
+         zhvar(:,:,:) = pv_i(:,:,:) * z1_ai(:,:,:)
+         CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho , zva_ho , zcu_box, zcv_box, zhvar, pv_i )    ! Ice volume
+         IF( ll_thickness )   pv_i(:,:,:) = zhvar(:,:,:) * pa_i(:,:,:)
+         !
+         zhvar(:,:,:) = pv_s(:,:,:) * z1_ai(:,:,:)
+         CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho , zva_ho , zcu_box, zcv_box, zhvar, pv_s )    ! Snw volume
+         IF( ll_thickness )   pv_s(:,:,:) = zhvar(:,:,:) * pa_i(:,:,:)
+         !
+         zhvar(:,:,:) = psv_i(:,:,:) * z1_ai(:,:,:)
+         CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho , zva_ho , zcu_box, zcv_box, zhvar, psv_i )    ! Salt content
+         !
+         zhvar(:,:,:) = poa_i(:,:,:) * z1_ai(:,:,:)
+         CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho , zva_ho , zcu_box, zcv_box, zhvar, poa_i )    ! Age content
+         !
+         DO jk = 1, nlay_i
+            zhvar(:,:,:) = pe_i(:,:,jk,:) * z1_ai(:,:,:)
+            CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho, zva_ho, zcu_box, zcv_box, zhvar, pe_i(:,:,jk,:) ) ! Ice heat content
+         END DO
+         !
+         DO jk = 1, nlay_s
+            zhvar(:,:,:) = pe_s(:,:,jk,:) * z1_ai(:,:,:)
+            CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho, zva_ho, zcu_box, zcv_box, zhvar, pe_s(:,:,jk,:) ) ! Snw heat content
+         END DO
+            !
+         IF ( ln_pnd_H12 ) THEN
+            !
+            DO jl = 1, jpl
+               zua_ho(:,:,jl) = zudy(:,:)
+               zva_ho(:,:,jl) = zvdx(:,:)
+            END DO
+            
             zamsk = 1._wp
-            CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zudy, zvdx, zcu_box, zcv_box, pa_i(:,:,jl), pa_i(:,:,jl), &        ! Ice area
-               &          zua_ho, zva_ho )
+            CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho, zva_ho, zcu_box, zcv_box, pa_ip, pa_ip, zua_ho, zva_ho ) ! mp fraction
             zamsk = 0._wp
             !
-            IF( ll_thickness ) THEN
-               zua_ho(:,:) = zudy(:,:)
-               zva_ho(:,:) = zvdx(:,:)
-            ENDIF
-            !
-            zhvar(:,:) = pv_i(:,:,jl) * z1_ai(:,:)
-            CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho , zva_ho , zcu_box, zcv_box, zhvar(:,:), pv_i (:,:,jl) )    ! Ice volume
-            IF( ll_thickness )   pv_i(:,:,jl) = zhvar(:,:) * pa_i(:,:,jl)
-            !
-            zhvar(:,:) = pv_s(:,:,jl) * z1_ai(:,:)
-            CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho , zva_ho , zcu_box, zcv_box, zhvar(:,:), pv_s (:,:,jl) )    ! Snw volume
-            IF( ll_thickness )   pv_s(:,:,jl) = zhvar(:,:) * pa_i(:,:,jl)
-            !
-            zhvar(:,:) = psv_i(:,:,jl) * z1_ai(:,:)
-            CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho , zva_ho , zcu_box, zcv_box, zhvar(:,:), psv_i(:,:,jl) )    ! Salt content
-            !
-            zhvar(:,:) = poa_i(:,:,jl) * z1_ai(:,:)
-            CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho , zva_ho , zcu_box, zcv_box, zhvar(:,:), poa_i(:,:,jl) )    ! Age content
-            !
-            DO jk = 1, nlay_i
-               zhvar(:,:) = pe_i(:,:,jk,jl) * z1_ai(:,:)
-               CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho, zva_ho, zcu_box, zcv_box, zhvar(:,:), pe_i(:,:,jk,jl) ) ! Ice heat content
-            END DO
-            !
-            DO jk = 1, nlay_s
-               zhvar(:,:) = pe_s(:,:,jk,jl) * z1_ai(:,:)
-               CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho, zva_ho, zcu_box, zcv_box, zhvar(:,:), pe_s(:,:,jk,jl) ) ! Snw heat content
-            END DO
-            !
-            IF ( ln_pnd_H12 ) THEN
-               !
-               zamsk = 1._wp
-               CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zudy, zvdx, zcu_box, zcv_box, pa_ip(:,:,jl), pa_ip(:,:,jl), &   ! mp fraction
-                  &          zua_ho, zva_ho )
-               zamsk = 0._wp
-
-               zhvar(:,:) = pv_ip(:,:,jl) * z1_ai(:,:)
-               CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho , zva_ho , zcu_box, zcv_box, zhvar(:,:), pv_ip(:,:,jl) ) ! mp volume
-            ENDIF
-            !
-            !
-         END DO
-         !
-         IF( .NOT. ll_ADVopw ) THEN
+            zhvar(:,:,:) = pv_ip(:,:,:) * z1_ai(:,:,:)
+            CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho , zva_ho , zcu_box, zcv_box, zhvar, pv_ip ) ! mp volume
+         ENDIF
+         !
+         !
+!!$         IF( .NOT. ll_ADVopw ) THEN
             zati2(:,:) = SUM( pa_i(:,:,:), dim=3 )
             DO jj = 2, jpjm1
@@ -253,6 +273,6 @@
                END DO
             END DO
-            CALL lbc_lnk( pato_i(:,:), 'T',  1. )
-         ENDIF
+            CALL lbc_lnk( 'icedyn_adv_umx', pato_i(:,:), 'T',  1. )
+!!$         ENDIF
          !
       END DO
@@ -279,16 +299,16 @@
       INTEGER                     , INTENT(in   )           ::   kt             ! number of iteration
       REAL(wp)                    , INTENT(in   )           ::   pdt            ! tracer time-step
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   )           ::   pu   , pv      ! 2 ice velocity components => u*e2
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   )           ::   puc  , pvc     ! 2 ice velocity components => u*e2 or u*a*e2u
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   )           ::   pubox, pvbox   ! upstream velocity
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout)           ::   pt             ! tracer field
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout)           ::   ptc            ! tracer content field
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(  out), OPTIONAL ::   pua_ho, pva_ho ! high order u*a fluxes
-      !
-      INTEGER  ::   ji, jj           ! dummy loop indices  
+      REAL(wp), DIMENSION(:,:  ), INTENT(in   )           ::   pu   , pv      ! 2 ice velocity components => u*e2
+      REAL(wp), DIMENSION(:,:,:), INTENT(in   )           ::   puc  , pvc     ! 2 ice velocity components => u*e2 or u*a*e2u
+      REAL(wp), DIMENSION(:,:  ), INTENT(in   )           ::   pubox, pvbox   ! upstream velocity
+      REAL(wp), DIMENSION(:,:,:), INTENT(inout)           ::   pt             ! tracer field
+      REAL(wp), DIMENSION(:,:,:), INTENT(inout)           ::   ptc            ! tracer content field
+      REAL(wp), DIMENSION(jpi,jpj,jpl), INTENT(  out), OPTIONAL ::   pua_ho, pva_ho ! high order u*a fluxes
+      !
+      INTEGER  ::   ji, jj, jl       ! dummy loop indices  
       REAL(wp) ::   ztra             ! local scalar
       INTEGER  ::   kn_limiter = 1   ! 1=nonosc ; 2=superbee ; 3=h3(rachid)
-      REAL(wp), DIMENSION(jpi,jpj) ::   zfu_ho , zfv_ho , zt_u, zt_v, zpt
-      REAL(wp), DIMENSION(jpi,jpj) ::   zfu_ups, zfv_ups, zt_ups   ! only for nonosc 
+      REAL(wp), DIMENSION(jpi,jpj,jpl) ::   zfu_ho , zfv_ho , zt_u, zt_v, zpt
+      REAL(wp), DIMENSION(jpi,jpj,jpl) ::   zfu_ups, zfv_ups, zt_ups   ! only for nonosc 
       !!----------------------------------------------------------------------
       !
@@ -297,11 +317,14 @@
 
       IF( ll_gurvan .AND. pamsk==0. ) THEN
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1
-               pt(ji,jj) = ( pt (ji,jj) + pt(ji,jj) * pdt * ( pu(ji,jj) - pu(ji-1,jj) ) * r1_e1e2t(ji,jj) &
-                  &                     + pt(ji,jj) * pdt * ( pv(ji,jj) - pv(ji,jj-1) ) * r1_e1e2t(ji,jj) ) * tmask(ji,jj,1)
-            END DO
-         END DO
-         CALL lbc_lnk( pt, 'T', 1. )
+         DO jl = 1, jpl
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1
+                  pt(ji,jj,jl) = ( pt (ji,jj,jl) + pt(ji,jj,jl) * pdt * ( pu(ji,jj) - pu(ji-1,jj) ) * r1_e1e2t(ji,jj)     &
+                     &                           + pt(ji,jj,jl) * pdt * ( pv(ji,jj) - pv(ji,jj-1) ) * r1_e1e2t(ji,jj) )   &
+                     &           * tmask(ji,jj,1)
+               END DO
+            END DO
+         END DO
+         CALL lbc_lnk( 'icedyn_adv_umx', pt, 'T', 1. )
       ENDIF
 
@@ -310,108 +333,121 @@
 
          ! fluxes in both x-y directions
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1
-               IF( ll_clem ) THEN
-                  zfu_ups(ji,jj) = MAX( pu(ji,jj), 0._wp ) * pt(ji,jj) + MIN( pu(ji,jj), 0._wp ) * pt(ji+1,jj)
-                  zfv_ups(ji,jj) = MAX( pv(ji,jj), 0._wp ) * pt(ji,jj) + MIN( pv(ji,jj), 0._wp ) * pt(ji,jj+1)
-               ELSE
-                  zfu_ups(ji,jj) = MAX( puc(ji,jj), 0._wp ) * pt(ji,jj) + MIN( puc(ji,jj), 0._wp ) * pt(ji+1,jj)
-                  zfv_ups(ji,jj) = MAX( pvc(ji,jj), 0._wp ) * pt(ji,jj) + MIN( pvc(ji,jj), 0._wp ) * pt(ji,jj+1)
-               ENDIF
-            END DO
-         END DO
-
-      ELSE
-         !
-         IF( MOD( (kt - 1) / nn_fsbc , 2 ) ==  MOD( (jt - 1) , 2 ) ) THEN   !==  odd ice time step:  adv_x then adv_y  ==!
-            ! flux in x-direction
+         DO jl = 1, jpl
             DO jj = 1, jpjm1
                DO ji = 1, fs_jpim1
                   IF( ll_clem ) THEN
-                     zfu_ups(ji,jj) = MAX( pu(ji,jj), 0._wp ) * pt(ji,jj) + MIN( pu(ji,jj), 0._wp ) * pt(ji+1,jj)
+                     zfu_ups(ji,jj,jl) = MAX( pu(ji,jj), 0._wp ) * pt(ji,jj,jl) + MIN( pu(ji,jj), 0._wp ) * pt(ji+1,jj,jl)
+                     zfv_ups(ji,jj,jl) = MAX( pv(ji,jj), 0._wp ) * pt(ji,jj,jl) + MIN( pv(ji,jj), 0._wp ) * pt(ji,jj+1,jl)
                   ELSE
-                     zfu_ups(ji,jj) = MAX( puc(ji,jj), 0._wp ) * pt(ji,jj) + MIN( puc(ji,jj), 0._wp ) * pt(ji+1,jj)
-                  ENDIF
+                     zfu_ups(ji,jj,jl) = MAX( puc(ji,jj,jl), 0._wp ) * pt(ji,jj,jl) + MIN( puc(ji,jj,jl), 0._wp ) * pt(ji+1,jj,jl)
+                     zfv_ups(ji,jj,jl) = MAX( pvc(ji,jj,jl), 0._wp ) * pt(ji,jj,jl) + MIN( pvc(ji,jj,jl), 0._wp ) * pt(ji,jj+1,jl)
+                  ENDIF
+               END DO
+            END DO
+         END DO
+
+      ELSE
+         !
+         IF( MOD( (kt - 1) / nn_fsbc , 2 ) ==  MOD( (jt - 1) , 2 ) ) THEN   !==  odd ice time step:  adv_x then adv_y  ==!
+            ! flux in x-direction
+            DO jl = 1, jpl
+               DO jj = 1, jpjm1
+                  DO ji = 1, fs_jpim1
+                     IF( ll_clem ) THEN
+                        zfu_ups(ji,jj,jl) = MAX( pu(ji,jj), 0._wp ) * pt(ji,jj,jl) + MIN( pu(ji,jj), 0._wp ) * pt(ji+1,jj,jl)
+                     ELSE
+                        zfu_ups(ji,jj,jl) = MAX( puc(ji,jj,jl), 0._wp ) * pt(ji,jj,jl) + MIN( puc(ji,jj,jl), 0._wp ) * pt(ji+1,jj,jl)
+                     ENDIF
+                  END DO
                END DO
             END DO
             
             ! first guess of tracer content from u-flux
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  IF( ll_clem ) THEN
-                     IF( ll_gurvan ) THEN
-                        zpt(ji,jj) = ( pt(ji,jj) - ( zfu_ups(ji,jj) - zfu_ups(ji-1,jj) ) * pdt * r1_e1e2t(ji,jj) ) * tmask(ji,jj,1)
+            DO jl = 1, jpl
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     IF( ll_clem ) THEN
+                        IF( ll_gurvan ) THEN
+                           zpt(ji,jj,jl) = ( pt(ji,jj,jl) - ( zfu_ups(ji,jj,jl) - zfu_ups(ji-1,jj,jl) ) * pdt * r1_e1e2t(ji,jj) ) * tmask(ji,jj,1)
+                        ELSE
+                           zpt(ji,jj,jl) = ( pt(ji,jj,jl) - ( zfu_ups(ji,jj,jl) - zfu_ups(ji-1,jj,jl) ) * pdt * r1_e1e2t(ji,jj)  &
+                              &            + pt(ji,jj,jl) * pdt * ( pu(ji,jj) - pu(ji-1,jj) ) * r1_e1e2t(ji,jj) * (1.-pamsk) &
+                              &            ) * tmask(ji,jj,1)
+                        ENDIF
                      ELSE
-                        zpt(ji,jj) = ( pt(ji,jj) - ( zfu_ups(ji,jj) - zfu_ups(ji-1,jj) ) * pdt * r1_e1e2t(ji,jj)  &
-                           &                     + pt(ji,jj) * pdt * ( pu(ji,jj) - pu(ji-1,jj) ) * r1_e1e2t(ji,jj) * (1.-pamsk) &
-                           &         ) * tmask(ji,jj,1)
-                     ENDIF
-                  ELSE
-                     zpt(ji,jj) = ( ptc(ji,jj) - ( zfu_ups(ji,jj) - zfu_ups(ji-1,jj) ) * pdt * r1_e1e2t(ji,jj) ) &
-                        &         * tmask(ji,jj,1)
-                  ENDIF
-!!                  IF( ji==26 .AND. jj==86) THEN
-!!                     WRITE(numout,*) '************************'
-!!                     WRITE(numout,*) 'zpt upstream',zpt(ji,jj)
-!!                  ENDIF
-               END DO
-            END DO
-            CALL lbc_lnk( zpt, 'T', 1. )
+                        zpt(ji,jj,jl) = ( ptc(ji,jj,jl) - ( zfu_ups(ji,jj,jl) - zfu_ups(ji-1,jj,jl) ) * pdt * r1_e1e2t(ji,jj) ) &
+                           &         * tmask(ji,jj,1)
+                     ENDIF
+                     !!                  IF( ji==26 .AND. jj==86) THEN
+                     !!                     WRITE(numout,*) '************************'
+                     !!                     WRITE(numout,*) 'zpt upstream',zpt(ji,jj)
+                     !!                  ENDIF
+                  END DO
+               END DO
+            END DO
+            CALL lbc_lnk( 'icedyn_adv_umx', zpt, 'T', 1. )
             !
             ! flux in y-direction
-            DO jj = 1, jpjm1
-               DO ji = 1, fs_jpim1
-                  IF( ll_clem ) THEN
-                     zfv_ups(ji,jj) = MAX( pv(ji,jj), 0._wp ) * zpt(ji,jj) + MIN( pv(ji,jj), 0._wp ) * zpt(ji,jj+1)
-                  ELSE
-                     zfv_ups(ji,jj) = MAX( pvc(ji,jj), 0._wp ) * zpt(ji,jj) + MIN( pvc(ji,jj), 0._wp ) * zpt(ji,jj+1)
-                  ENDIF
-               END DO
-            END DO
-
+            DO jl = 1, jpl
+               DO jj = 1, jpjm1
+                  DO ji = 1, fs_jpim1
+                     IF( ll_clem ) THEN
+                        zfv_ups(ji,jj,jl) = MAX( pv(ji,jj), 0._wp ) * zpt(ji,jj,jl) + MIN( pv(ji,jj), 0._wp ) * zpt(ji,jj+1,jl)
+                     ELSE
+                        zfv_ups(ji,jj,jl) = MAX( pvc(ji,jj,jl), 0._wp ) * zpt(ji,jj,jl) + MIN( pvc(ji,jj,jl), 0._wp ) * zpt(ji,jj+1,jl)
+                     ENDIF
+                  END DO
+               END DO
+            END DO
          !
          ELSE                                                               !==  even ice time step:  adv_y then adv_x  ==!
             ! flux in y-direction
-            DO jj = 1, jpjm1
-               DO ji = 1, fs_jpim1
-                  IF( ll_clem ) THEN
-                     zfv_ups(ji,jj) = MAX( pv(ji,jj), 0._wp ) * pt(ji,jj) + MIN( pv(ji,jj), 0._wp ) * pt(ji,jj+1)
-                  ELSE
-                     zfv_ups(ji,jj) = MAX( pvc(ji,jj), 0._wp ) * pt(ji,jj) + MIN( pvc(ji,jj), 0._wp ) * pt(ji,jj+1)
-                  ENDIF
+            DO jl = 1, jpl
+               DO jj = 1, jpjm1
+                  DO ji = 1, fs_jpim1
+                     IF( ll_clem ) THEN
+                        zfv_ups(ji,jj,jl) = MAX( pv(ji,jj), 0._wp ) * pt(ji,jj,jl) + MIN( pv(ji,jj), 0._wp ) * pt(ji,jj+1,jl)
+                     ELSE
+                        zfv_ups(ji,jj,jl) = MAX( pvc(ji,jj,jl), 0._wp ) * pt(ji,jj,jl) + MIN( pvc(ji,jj,jl), 0._wp ) * pt(ji,jj+1,jl)
+                     ENDIF
+                  END DO
                END DO
             END DO
 
             ! first guess of tracer content from v-flux
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  IF( ll_clem ) THEN
-                     IF( ll_gurvan ) THEN
-                        zpt(ji,jj) = ( pt(ji,jj) - ( zfv_ups(ji,jj) - zfv_ups(ji,jj-1) ) * pdt * r1_e1e2t(ji,jj) ) * tmask(ji,jj,1)
+            DO jl = 1, jpl
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     IF( ll_clem ) THEN
+                        IF( ll_gurvan ) THEN
+                           zpt(ji,jj,jl) = ( pt(ji,jj,jl) - ( zfv_ups(ji,jj,jl) - zfv_ups(ji,jj-1,jl) ) * pdt * r1_e1e2t(ji,jj) ) * tmask(ji,jj,1)
+                        ELSE
+                           zpt(ji,jj,jl) = ( pt(ji,jj,jl) - ( zfv_ups(ji,jj,jl) - zfv_ups(ji,jj-1,jl) ) * pdt * r1_e1e2t(ji,jj) &
+                              &            + pt(ji,jj,jl) * pdt * ( pv(ji,jj) - pv(ji,jj-1) ) * r1_e1e2t(ji,jj) * (1.-pamsk) ) &
+                              &            * tmask(ji,jj,1)
+                        ENDIF
                      ELSE
-                        zpt(ji,jj) = ( pt(ji,jj) - ( zfv_ups(ji,jj) - zfv_ups(ji,jj-1) ) * pdt * r1_e1e2t(ji,jj) &
-                        &                        + pt(ji,jj) * pdt * ( pv(ji,jj) - pv(ji,jj-1) ) * r1_e1e2t(ji,jj) * (1.-pamsk) ) &
-                        &         * tmask(ji,jj,1)
-                     ENDIF
-                  ELSE
-                     zpt(ji,jj) = ( ptc(ji,jj) - ( zfv_ups(ji,jj) - zfv_ups(ji,jj-1) ) * pdt * r1_e1e2t(ji,jj) ) &
-                        &         * tmask(ji,jj,1)
-                  ENDIF
-!!                  IF( ji==26 .AND. jj==86) THEN
-!!                     WRITE(numout,*) '************************'
-!!                     WRITE(numout,*) 'zpt upstream',zpt(ji,jj)
-!!                  ENDIF
-                END DO
-            END DO
-            CALL lbc_lnk( zpt, 'T', 1. )
+                        zpt(ji,jj,jl) = ( ptc(ji,jj,jl) - ( zfv_ups(ji,jj,jl) - zfv_ups(ji,jj-1,jl) ) * pdt * r1_e1e2t(ji,jj) ) &
+                           &            * tmask(ji,jj,1)
+                     ENDIF
+                     !!                  IF( ji==26 .AND. jj==86) THEN
+                     !!                     WRITE(numout,*) '************************'
+                     !!                     WRITE(numout,*) 'zpt upstream',zpt(ji,jj)
+                     !!                  ENDIF
+                  END DO
+               END DO
+            END DO
+            CALL lbc_lnk( 'icedyn_adv_umx', zpt, 'T', 1. )
             !
             ! flux in x-direction
-            DO jj = 1, jpjm1
-               DO ji = 1, fs_jpim1
-                  IF( ll_clem ) THEN
-                     zfu_ups(ji,jj) = MAX( pu(ji,jj), 0._wp ) * zpt(ji,jj) + MIN( pu(ji,jj), 0._wp ) * zpt(ji+1,jj)
-                  ELSE
-                     zfu_ups(ji,jj) = MAX( puc(ji,jj), 0._wp ) * zpt(ji,jj) + MIN( puc(ji,jj), 0._wp ) * zpt(ji+1,jj)
-                  ENDIF
+            DO jl = 1, jpl
+               DO jj = 1, jpjm1
+                  DO ji = 1, fs_jpim1
+                     IF( ll_clem ) THEN
+                        zfu_ups(ji,jj,jl) = MAX( pu(ji,jj), 0._wp ) * zpt(ji,jj,jl) + MIN( pu(ji,jj), 0._wp ) * zpt(ji+1,jj,jl)
+                     ELSE
+                        zfu_ups(ji,jj,jl) = MAX( puc(ji,jj,jl), 0._wp ) * zpt(ji,jj,jl) + MIN( puc(ji,jj,jl), 0._wp ) * zpt(ji+1,jj,jl)
+                     ENDIF
+                  END DO
                END DO
             END DO
@@ -425,8 +461,10 @@
 
       IF( ll_zeroup2 ) THEN
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
-               IF( amaxu(ji,jj) == 0._wp )   zfu_ups(ji,jj) = 0._wp
-               IF( amaxv(ji,jj) == 0._wp )   zfv_ups(ji,jj) = 0._wp
+         DO jl = 1, jpl
+            DO jj = 1, jpjm1
+               DO ji = 1, fs_jpim1   ! vector opt.
+                  IF( amaxu(ji,jj,jl) == 0._wp )   zfu_ups(ji,jj,jl) = 0._wp
+                  IF( amaxv(ji,jj,jl) == 0._wp )   zfv_ups(ji,jj,jl) = 0._wp
+               END DO
             END DO
          END DO
@@ -434,26 +472,28 @@
 
       ! guess after content field with upstream scheme
-      DO jj = 2, jpjm1
-         DO ji = fs_2, fs_jpim1
-            ztra          = - (   zfu_ups(ji,jj) - zfu_ups(ji-1,jj  )   &
-               &                + zfv_ups(ji,jj) - zfv_ups(ji  ,jj-1) ) * r1_e1e2t(ji,jj)
-            IF( ll_clem ) THEN
-               IF( ll_gurvan ) THEN
-                  zt_ups(ji,jj) = ( pt (ji,jj) + pdt * ztra ) * tmask(ji,jj,1)
+      DO jl = 1, jpl
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1
+               ztra          = - (   zfu_ups(ji,jj,jl) - zfu_ups(ji-1,jj  ,jl)   &
+                  &                + zfv_ups(ji,jj,jl) - zfv_ups(ji  ,jj-1,jl) ) * r1_e1e2t(ji,jj)
+               IF( ll_clem ) THEN
+                  IF( ll_gurvan ) THEN
+                     zt_ups(ji,jj,jl) = ( pt (ji,jj,jl) + pdt * ztra ) * tmask(ji,jj,1)
+                  ELSE
+                     zt_ups(ji,jj,jl) = ( pt (ji,jj,jl) + pdt * ztra + ( pt(ji,jj,jl) * pdt * ( pu(ji,jj) - pu(ji-1,jj) )   &
+                        &                                            +   pt(ji,jj,jl) * pdt * ( pv(ji,jj) - pv(ji,jj-1) ) ) &
+                        &                                              * r1_e1e2t(ji,jj) * (1.-pamsk) ) * tmask(ji,jj,1)
+                  ENDIF
                ELSE
-                  zt_ups(ji,jj) = ( pt (ji,jj) + pdt * ztra + ( pt(ji,jj) * pdt * ( pu(ji,jj) - pu(ji-1,jj) )   &
-                     &                                      +   pt(ji,jj) * pdt * ( pv(ji,jj) - pv(ji,jj-1) ) ) &
-                     &                                        * r1_e1e2t(ji,jj) * (1.-pamsk) ) * tmask(ji,jj,1)
+                  zt_ups(ji,jj,jl) = ( ptc(ji,jj,jl) + pdt * ztra ) * tmask(ji,jj,1)
                ENDIF
-            ELSE
-               zt_ups(ji,jj) = ( ptc(ji,jj) + pdt * ztra ) * tmask(ji,jj,1)
-            ENDIF
-!!            IF( ji==26 .AND. jj==86) THEN
-!!               WRITE(numout,*) '**************************'
-!!               WRITE(numout,*) 'zt upstream',zt_ups(ji,jj)
-!!            ENDIF
+               !!            IF( ji==26 .AND. jj==86) THEN
+               !!               WRITE(numout,*) '**************************'
+               !!               WRITE(numout,*) 'zt upstream',zt_ups(ji,jj)
+               !!            ENDIF
+            END DO
          END DO
       END DO
-      CALL lbc_lnk( zt_ups, 'T', 1. )
+      CALL lbc_lnk( 'icedyn_adv_umx', zt_ups, 'T', 1. )
 
       ! High order (_ho) fluxes 
@@ -476,27 +516,29 @@
          ! final trend with corrected fluxes
          ! ------------------------------------
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1
-               IF( ll_gurvan ) THEN
-                  ztra       = - ( zfu_ho(ji,jj) - zfu_ho(ji-1,jj) + zfv_ho(ji,jj) - zfv_ho(ji,jj-1) ) * r1_e1e2t(ji,jj) 
-               ELSE
-                  ztra       = ( - ( zfu_ho(ji,jj) - zfu_ho(ji-1,jj) + zfv_ho(ji,jj) - zfv_ho(ji,jj-1) )  & 
-                     &           + ( pt(ji,jj) * ( pu(ji,jj) - pu(ji-1,jj) ) * (1.-pamsk) ) &
-                     &           + ( pt(ji,jj) * ( pv(ji,jj) - pv(ji,jj-1) ) * (1.-pamsk) ) ) * r1_e1e2t(ji,jj)
-               ENDIF
-               pt(ji,jj) = ( pt(ji,jj) + pdt * ztra ) * tmask(ji,jj,1)
-
-               IF( pt(ji,jj) < -epsi20 ) THEN
-                  WRITE(numout,*) 'T<0 ',pt(ji,jj)
-               ENDIF
-               
-               IF( pt(ji,jj) < 0._wp .AND. pt(ji,jj) >= -epsi20 )   pt(ji,jj) = 0._wp
-               
-!!               IF( ji==26 .AND. jj==86) THEN
-!!                  WRITE(numout,*) 'zt high order',pt(ji,jj)
-!!               ENDIF
-            END DO
-         END DO
-         CALL lbc_lnk( pt, 'T',  1. )
+         DO jl = 1, jpl
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1
+                  IF( ll_gurvan ) THEN
+                     ztra       = - ( zfu_ho(ji,jj,jl) - zfu_ho(ji-1,jj,jl) + zfv_ho(ji,jj,jl) - zfv_ho(ji,jj-1,jl) ) * r1_e1e2t(ji,jj) 
+                  ELSE
+                     ztra       = ( - ( zfu_ho(ji,jj,jl) - zfu_ho(ji-1,jj,jl) + zfv_ho(ji,jj,jl) - zfv_ho(ji,jj-1,jl) )  & 
+                        &           + ( pt(ji,jj,jl) * ( pu(ji,jj) - pu(ji-1,jj) ) * (1.-pamsk) ) &
+                        &           + ( pt(ji,jj,jl) * ( pv(ji,jj) - pv(ji,jj-1) ) * (1.-pamsk) ) ) * r1_e1e2t(ji,jj)
+                  ENDIF
+                  pt(ji,jj,jl) = ( pt(ji,jj,jl) + pdt * ztra ) * tmask(ji,jj,1)
+                  
+                  IF( pt(ji,jj,jl) < -epsi20 ) THEN
+                     WRITE(numout,*) 'T<0 ',pt(ji,jj,jl)
+                  ENDIF
+                  
+                  IF( pt(ji,jj,jl) < 0._wp .AND. pt(ji,jj,jl) >= -epsi20 )   pt(ji,jj,jl) = 0._wp
+                  
+                  !!               IF( ji==26 .AND. jj==86) THEN
+                  !!                  WRITE(numout,*) 'zt high order',pt(ji,jj)
+                  !!               ENDIF
+               END DO
+            END DO
+         END DO
+         CALL lbc_lnk( 'icedyn_adv_umx', pt, 'T',  1. )
       ENDIF
    
